'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Pane = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMotion = require('react-motion');

var _lodash = require('lodash.range');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactResizableBox = require('react-resizable-box');

var _reactResizableBox2 = _interopRequireDefault(_reactResizableBox);

var _lodash3 = require('lodash.isequal');

var _lodash4 = _interopRequireDefault(_lodash3);

var _pane = require('./pane');

var _pane2 = _interopRequireDefault(_pane);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.Pane = _pane2.default;

var reinsert = function reinsert(array, from, to) {
  var a = array.slice(0);
  var v = a[from];
  a.splice(from, 1);
  a.splice(to, 0, v);
  return a;
};

var clamp = function clamp(n) {
  var min = arguments.length <= 1 || arguments[1] === undefined ? n : arguments[1];
  var max = arguments.length <= 2 || arguments[2] === undefined ? n : arguments[2];
  return Math.max(Math.min(n, max), min);
};

var springConfig = [500, 30];

var SortablePane = function (_Component) {
  _inherits(SortablePane, _Component);

  function SortablePane(props) {
    _classCallCheck(this, SortablePane);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(SortablePane).call(this, props));

    _this.state = {
      delta: 0,
      mouse: 0,
      isPressed: false,
      lastPressed: 0,
      order: (0, _lodash2.default)(_this.props.children.length),
      widthList: (0, _lodash2.default)(_this.props.children.length).map(function () {
        return 0;
      }),
      isResizing: false
    };
    _this.handleTouchMove = _this.handleTouchMove.bind(_this);
    _this.handleMouseUp = _this.handleMouseUp.bind(_this);
    _this.handleMouseMove = _this.handleMouseMove.bind(_this);

    window.addEventListener('touchmove', _this.handleTouchMove);
    window.addEventListener('touchend', _this.handleMouseUp);
    window.addEventListener('mousemove', _this.handleMouseMove);
    window.addEventListener('mouseup', _this.handleMouseUp);
    return _this;
  }

  _createClass(SortablePane, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setWidth();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('touchmove', this.handleTouchMove);
      window.removeEventListener('touchend', this.handleMouseUp);
      window.removeEventListener('mousemove', this.handleMouseMove);
      window.removeEventListener('mouseup', this.handleMouseUp);
    }
  }, {
    key: 'onResize',
    value: function onResize(i, _ref) {
      var width = _ref.width;
      var _state = this.state;
      var widthList = _state.widthList;
      var order = _state.order;

      widthList[order.indexOf(i)] = width;
      this.setState({ widthList: widthList });
      this.forceUpdate();
      this.props.onResize(i);
    }
  }, {
    key: 'getItemCountByPositionX',
    value: function getItemCountByPositionX(x) {
      var widthList = this.state.widthList;
      var margin = this.props.margin;

      var sum = 0;
      if (x < 0) return 0;
      for (var i = 0; i < widthList.length; i++) {
        sum += widthList[i] + margin;
        if (sum >= x) return i + 1;
      }
      return widthList.length;
    }
  }, {
    key: 'setWidth',
    value: function setWidth() {
      var children = Array.prototype.slice.call(this.refs.panes.children);
      var width = children.map(function (child) {
        return child.clientWidth;
      });
      this.setState({ widthList: width });
    }
  }, {
    key: 'getItemPositionXByIndex',
    value: function getItemPositionXByIndex(index) {
      var widthList = this.state.widthList;

      var sum = 0;
      for (var i = 0; i < index; i++) {
        sum += widthList[i] + this.props.margin;
      }return sum;
    }
  }, {
    key: 'handleResizeStart',
    value: function handleResizeStart(i) {
      this.setState({ isResizing: true });
      this.props.onResizeStart(i);
    }
  }, {
    key: 'handleResizeStop',
    value: function handleResizeStop(i) {
      this.setState({ isResizing: false });
      this.props.onResizeStop(i);
    }
  }, {
    key: 'handleMouseDown',
    value: function handleMouseDown(pos, pressX, _ref2) {
      var pageX = _ref2.pageX;

      this.setState({
        delta: pageX - pressX,
        mouse: pressX,
        isPressed: true,
        lastPressed: pos
      });
    }
  }, {
    key: 'handleMouseMove',
    value: function handleMouseMove(_ref3) {
      var pageX = _ref3.pageX;
      var _state2 = this.state;
      var isPressed = _state2.isPressed;
      var delta = _state2.delta;
      var order = _state2.order;
      var lastPressed = _state2.lastPressed;
      var widthList = _state2.widthList;
      var isResizing = _state2.isResizing;

      if (isPressed && !isResizing) {
        var mouse = pageX - delta;
        var length = this.props.children.length;

        var row = clamp(Math.round(this.getItemCountByPositionX(mouse)), 0, length - 1);
        var newOrder = reinsert(order, order.indexOf(lastPressed), row);
        var newWidthList = reinsert(widthList, order.indexOf(lastPressed), row);
        this.setState({ mouse: mouse, order: newOrder, widthList: newWidthList });
        if (!(0, _lodash4.default)(order, newOrder)) this.props.onOrderChange(newOrder);
      }
    }
  }, {
    key: 'handleTouchStart',
    value: function handleTouchStart(key, pressLocation, e) {
      this.handleMouseDown(key, pressLocation, e.touches[0]);
    }
  }, {
    key: 'handleTouchMove',
    value: function handleTouchMove(e) {
      e.preventDefault();
      this.handleMouseMove(e.touches[0]);
    }
  }, {
    key: 'handleMouseUp',
    value: function handleMouseUp() {
      this.setState({ isPressed: false, delta: 0 });
    }
  }, {
    key: 'renderPanes',
    value: function renderPanes() {
      var _this2 = this;

      var _state3 = this.state;
      var mouse = _state3.mouse;
      var isPressed = _state3.isPressed;
      var lastPressed = _state3.lastPressed;
      var order = _state3.order;
      var _props = this.props;
      var children = _props.children;
      var disableEffect = _props.disableEffect; // TODO: Add disableFloatEffect

      return children.map(function (child, i) {
        var style = lastPressed === i && isPressed ? {
          scale: disableEffect ? 1 : (0, _reactMotion.spring)(1.05, springConfig),
          shadow: disableEffect ? 0 : (0, _reactMotion.spring)(16, springConfig),
          x: mouse
        } : {
          scale: (0, _reactMotion.spring)(1, springConfig),
          shadow: (0, _reactMotion.spring)(0, springConfig),
          x: (0, _reactMotion.spring)(_this2.getItemPositionXByIndex(order.indexOf(i)), springConfig)
        };
        return _react2.default.createElement(
          _reactMotion.Motion,
          { style: style, key: i },
          function (_ref4) {
            var scale = _ref4.scale;
            var shadow = _ref4.shadow;
            var x = _ref4.x;

            var onResize = _this2.onResize.bind(_this2, i);
            var onMouseDown = _this2.handleMouseDown.bind(_this2, i, x);
            var onTouchStart = _this2.handleTouchStart.bind(_this2, i, x);
            var onResizeStart = _this2.handleResizeStart.bind(_this2, i);
            var onResizeStop = _this2.handleResizeStop.bind(_this2, i);
            return _react2.default.createElement(
              _reactResizableBox2.default,
              {
                customClass: _this2.props.customClass,
                onResize: onResize,
                isResizable: { x: true, y: false, xy: false },
                width: child.props.width,
                height: child.props.height,
                minWidth: child.props.minWidth,
                minHeight: child.props.minHeight,
                maxWidth: child.props.maxWidth,
                maxHeight: child.props.maxHeight,
                customStyle: Object.assign(child.props.style, {
                  boxShadow: 'rgba(0, 0, 0, 0.2) 0px ' + shadow + 'px ' + 2 * shadow + 'px 0px',
                  transform: 'translate3d(' + x + 'px, 0, 0) scale(' + scale + ')',
                  WebkitTransform: 'translate3d(' + x + 'px, 0, 0) scale(' + scale + ')',
                  zIndex: i === lastPressed ? 99 : i,
                  position: 'absolute'
                }),
                onMouseDown: onMouseDown,
                onTouchStart: onTouchStart,
                onResizeStart: onResizeStart,
                onResizeStop: onResizeStop
              },
              child.props.children
            );
          }
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var style = _props2.style;
      var customClass = _props2.customClass;

      return _react2.default.createElement(
        'div',
        {
          ref: 'panes',
          className: customClass,
          style: style
        },
        this.renderPanes()
      );
    }
  }]);

  return SortablePane;
}(_react.Component);

SortablePane.propTypes = {
  margin: _react.PropTypes.number,
  customClass: _react.PropTypes.string,
  style: _react.PropTypes.object,
  children: _react.PropTypes.array,
  onResizeStart: _react.PropTypes.func,
  onResize: _react.PropTypes.func,
  onResizeStop: _react.PropTypes.func,
  disableEffect: _react.PropTypes.bool,
  onOrderChange: _react.PropTypes.func
};
SortablePane.defaultProps = {
  margin: 0,
  onClick: function onClick() {
    return null;
  },
  onTouchStart: function onTouchStart() {
    return null;
  },
  onResizeStart: function onResizeStart() {
    return null;
  },
  onResize: function onResize() {
    return null;
  },
  onResizeStop: function onResizeStop() {
    return null;
  },
  onOrderChange: function onOrderChange() {
    return null;
  },
  customStyle: {},
  disableEffect: false
};
exports.default = SortablePane;